"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var keys_sync_exports = {};
__export(keys_sync_exports, {
  extractRawECDHPrivateKey: () => extractRawECDHPrivateKey,
  extractRawECDHPublicKey: () => extractRawECDHPublicKey,
  generateECDHKeyPair: () => generateECDHKeyPair,
  importRawECDHPrivateKey: () => importRawECDHPrivateKey,
  importRawECDHPublicKey: () => importRawECDHPublicKey,
  keyPairFromRawECDHPrivateKey: () => keyPairFromRawECDHPrivateKey
});
module.exports = __toCommonJS(keys_sync_exports);
var crypto = __toESM(require("node:crypto"), 1);
var import_shared = require("./shared.js");
function generateECDHKeyPair() {
  return crypto.generateKeyPairSync("x25519");
}
__name(generateECDHKeyPair, "generateECDHKeyPair");
function keyPairFromRawECDHPrivateKey(privateKey) {
  const privateKeyObject = importRawECDHPrivateKey(privateKey);
  const publicKeyObject = crypto.createPublicKey(privateKeyObject);
  return {
    privateKey: privateKeyObject,
    publicKey: publicKeyObject
  };
}
__name(keyPairFromRawECDHPrivateKey, "keyPairFromRawECDHPrivateKey");
function extractRawECDHPublicKey(publicKey) {
  return (0, import_shared.decodeX25519KeyDER)(publicKey.export({
    type: "spki",
    format: "der"
  }));
}
__name(extractRawECDHPublicKey, "extractRawECDHPublicKey");
function importRawECDHPublicKey(publicKey) {
  return crypto.createPublicKey({
    // eslint-disable-next-line no-restricted-globals -- crypto API requires Buffer instances
    key: Buffer.from((0, import_shared.encodeX25519KeyDERSPKI)(publicKey).buffer),
    format: "der",
    type: "spki"
  });
}
__name(importRawECDHPublicKey, "importRawECDHPublicKey");
function extractRawECDHPrivateKey(privateKey) {
  return (0, import_shared.decodeX25519KeyDER)(privateKey.export({
    type: "pkcs8",
    format: "der"
  }));
}
__name(extractRawECDHPrivateKey, "extractRawECDHPrivateKey");
function importRawECDHPrivateKey(privateKey) {
  return crypto.createPrivateKey({
    // eslint-disable-next-line no-restricted-globals -- crypto API requires Buffer instances
    key: Buffer.from((0, import_shared.encodeX25519KeyDERPKCS8)(privateKey).buffer),
    format: "der",
    type: "pkcs8"
  });
}
__name(importRawECDHPrivateKey, "importRawECDHPrivateKey");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  extractRawECDHPrivateKey,
  extractRawECDHPublicKey,
  generateECDHKeyPair,
  importRawECDHPrivateKey,
  importRawECDHPublicKey,
  keyPairFromRawECDHPrivateKey
});
//# sourceMappingURL=keys.sync.js.map
