"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var shared_safe_exports = {};
__export(shared_safe_exports, {
  CONTROL_CHAR_WIDTH: () => CONTROL_CHAR_WIDTH,
  LOG_PREFIX_WIDTH: () => LOG_PREFIX_WIDTH,
  LOG_WIDTH: () => LOG_WIDTH,
  channelPadding: () => channelPadding,
  directionPrefixPadding: () => directionPrefixPadding,
  getDirectionPrefix: () => getDirectionPrefix,
  getNodeTag: () => getNodeTag,
  nonUndefinedLogConfigKeys: () => nonUndefinedLogConfigKeys,
  stringToNodeList: () => stringToNodeList,
  timestampFormatShort: () => timestampFormatShort,
  timestampPadding: () => timestampPadding,
  timestampPaddingShort: () => timestampPaddingShort
});
module.exports = __toCommonJS(shared_safe_exports);
const timestampFormatShort = "HH:mm:ss.SSS";
const timestampPaddingShort = " ".repeat(timestampFormatShort.length + 1);
const timestampPadding = " ".repeat((/* @__PURE__ */ new Date()).toISOString().length + 1);
const channelPadding = " ".repeat(7);
function getDirectionPrefix(direction) {
  return direction === "inbound" ? "\xAB " : direction === "outbound" ? "\xBB " : "  ";
}
__name(getDirectionPrefix, "getDirectionPrefix");
const CONTROL_CHAR_WIDTH = 2;
const directionPrefixPadding = " ".repeat(CONTROL_CHAR_WIDTH);
const LOG_WIDTH = 80;
const LOG_PREFIX_WIDTH = 20;
function getNodeTag(nodeId) {
  return "Node " + nodeId.toString().padStart(3, "0");
}
__name(getNodeTag, "getNodeTag");
const nonUndefinedLogConfigKeys = [
  "enabled",
  "level",
  "transports",
  "logToFile",
  "maxFiles",
  "filename",
  "forceConsole"
];
function stringToNodeList(nodes) {
  if (!nodes)
    return void 0;
  return nodes.split(",").map((n) => parseInt(n)).filter((n) => !Number.isNaN(n));
}
__name(stringToNodeList, "stringToNodeList");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CONTROL_CHAR_WIDTH,
  LOG_PREFIX_WIDTH,
  LOG_WIDTH,
  channelPadding,
  directionPrefixPadding,
  getDirectionPrefix,
  getNodeTag,
  nonUndefinedLogConfigKeys,
  stringToNodeList,
  timestampFormatShort,
  timestampPadding,
  timestampPaddingShort
});
//# sourceMappingURL=shared_safe.js.map
