"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ctr_drbg_wrapper_exports = {};
__export(ctr_drbg_wrapper_exports, {
  CtrDRBG: () => CtrDRBG
});
module.exports = __toCommonJS(ctr_drbg_wrapper_exports);
var import_ctr_drbg_async = require("./ctr_drbg.async.js");
var import_ctr_drbg_sync = require("./ctr_drbg.sync.js");
class CtrDRBG {
  static {
    __name(this, "CtrDRBG");
  }
  drbgSync = new import_ctr_drbg_sync.CtrDrbgSync();
  drbgAsync = new import_ctr_drbg_async.CtrDrbgAsync();
  initSync(entropy, personalizationString) {
    this.drbgSync.init(entropy, personalizationString);
    this.drbgAsync.restoreState(this.drbgSync.saveState());
  }
  async initAsync(entropy, personalizationString) {
    await this.drbgAsync.init(entropy, personalizationString);
    this.drbgSync.restoreState(this.drbgAsync.saveState());
  }
  updateSync(providedData) {
    this.drbgSync.update(providedData);
    this.drbgAsync.restoreState(this.drbgSync.saveState());
  }
  async updateAsync(providedData) {
    await this.drbgAsync.update(providedData);
    this.drbgSync.restoreState(this.drbgAsync.saveState());
  }
  generateSync(len) {
    const ret = this.drbgSync.generate(len);
    this.drbgAsync.restoreState(this.drbgSync.saveState());
    return ret;
  }
  async generateAsync(len) {
    const ret = await this.drbgAsync.generate(len);
    this.drbgSync.restoreState(this.drbgAsync.saveState());
    return ret;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CtrDRBG
});
//# sourceMappingURL=ctr_drbg.wrapper.js.map
