"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var fs_exports = {};
__export(fs_exports, {
  copyFilesRecursive: () => copyFilesRecursive,
  enumFilesRecursive: () => enumFilesRecursive,
  pathExists: () => pathExists,
  readJSON: () => readJSON
});
module.exports = __toCommonJS(fs_exports);
var import_promises = __toESM(require("node:fs/promises"), 1);
var import_node_path = __toESM(require("node:path"), 1);
var import_errors = require("./errors.js");
async function enumFilesRecursive(rootDir, predicate) {
  const ret = [];
  try {
    const filesAndDirs = await import_promises.default.readdir(rootDir);
    for (const f of filesAndDirs) {
      const fullPath = import_node_path.default.join(rootDir, f);
      if ((await import_promises.default.stat(fullPath)).isDirectory()) {
        ret.push(...await enumFilesRecursive(fullPath, predicate));
      } else if (predicate == void 0 || predicate(fullPath)) {
        ret.push(fullPath);
      }
    }
  } catch (e) {
    console.error(`Cannot read directory: "${rootDir}": ${(0, import_errors.getErrorMessage)(e, true)}`);
  }
  return ret;
}
__name(enumFilesRecursive, "enumFilesRecursive");
async function copyFilesRecursive(sourceDir, targetDir, predicate) {
  const files = await enumFilesRecursive(sourceDir, predicate);
  for (const file of files) {
    const relative = import_node_path.default.relative(sourceDir, file);
    const target = import_node_path.default.join(targetDir, relative);
    await import_promises.default.mkdir(import_node_path.default.dirname(target), { recursive: true });
    await import_promises.default.copyFile(file, target);
  }
}
__name(copyFilesRecursive, "copyFilesRecursive");
async function readJSON(filename) {
  const data = await import_promises.default.readFile(filename, "utf8");
  return JSON.parse(data);
}
__name(readJSON, "readJSON");
async function pathExists(filename) {
  return import_promises.default.access(filename).then(() => true).catch(() => false);
}
__name(pathExists, "pathExists");
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  copyFilesRecursive,
  enumFilesRecursive,
  pathExists,
  readJSON
});
//# sourceMappingURL=fs.js.map
