"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ProtocolNodeMaskFiles_exports = {};
__export(ProtocolNodeMaskFiles_exports, {
  ProtocolAppRouteLockNodeMaskFile: () => ProtocolAppRouteLockNodeMaskFile,
  ProtocolAppRouteLockNodeMaskFileID: () => ProtocolAppRouteLockNodeMaskFileID,
  ProtocolLRNodeListFile: () => ProtocolLRNodeListFile,
  ProtocolLRNodeListFileID: () => ProtocolLRNodeListFileID,
  ProtocolNodeListFile: () => ProtocolNodeListFile,
  ProtocolNodeListFileID: () => ProtocolNodeListFileID,
  ProtocolNodeMaskFile: () => ProtocolNodeMaskFile,
  ProtocolPendingDiscoveryNodeMaskFile: () => ProtocolPendingDiscoveryNodeMaskFile,
  ProtocolPendingDiscoveryNodeMaskFileID: () => ProtocolPendingDiscoveryNodeMaskFileID,
  ProtocolPreferredRepeatersFile: () => ProtocolPreferredRepeatersFile,
  ProtocolPreferredRepeatersFileID: () => ProtocolPreferredRepeatersFileID,
  ProtocolRouteCacheExistsNodeMaskFile: () => ProtocolRouteCacheExistsNodeMaskFile,
  ProtocolRouteCacheExistsNodeMaskFileID: () => ProtocolRouteCacheExistsNodeMaskFileID,
  ProtocolRouteSlaveSUCNodeMaskFile: () => ProtocolRouteSlaveSUCNodeMaskFile,
  ProtocolRouteSlaveSUCNodeMaskFileID: () => ProtocolRouteSlaveSUCNodeMaskFileID,
  ProtocolSUCPendingUpdateNodeMaskFile: () => ProtocolSUCPendingUpdateNodeMaskFile,
  ProtocolSUCPendingUpdateNodeMaskFileID: () => ProtocolSUCPendingUpdateNodeMaskFileID,
  ProtocolVirtualNodeMaskFile: () => ProtocolVirtualNodeMaskFile,
  ProtocolVirtualNodeMaskFileID: () => ProtocolVirtualNodeMaskFileID
});
module.exports = __toCommonJS(ProtocolNodeMaskFiles_exports);
var import_safe = require("@zwave-js/core/safe");
var import_NVMFile = require("./NVMFile.js");
var __esDecorate = function(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
  function accept(f) {
    if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected");
    return f;
  }
  __name(accept, "accept");
  var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
  var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
  var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
  var _, done = false;
  for (var i = decorators.length - 1; i >= 0; i--) {
    var context = {};
    for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
    for (var p in contextIn.access) context.access[p] = contextIn.access[p];
    context.addInitializer = function(f) {
      if (done) throw new TypeError("Cannot add initializers after decoration has completed");
      extraInitializers.push(accept(f || null));
    };
    var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
    if (kind === "accessor") {
      if (result === void 0) continue;
      if (result === null || typeof result !== "object") throw new TypeError("Object expected");
      if (_ = accept(result.get)) descriptor.get = _;
      if (_ = accept(result.set)) descriptor.set = _;
      if (_ = accept(result.init)) initializers.unshift(_);
    } else if (_ = accept(result)) {
      if (kind === "field") initializers.unshift(_);
      else descriptor[key] = _;
    }
  }
  if (target) Object.defineProperty(target, contextIn.name, descriptor);
  done = true;
};
var __runInitializers = function(thisArg, initializers, value) {
  var useValue = arguments.length > 2;
  for (var i = 0; i < initializers.length; i++) {
    value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
  }
  return useValue ? value : void 0;
};
class ProtocolNodeMaskFile extends import_NVMFile.NVMFile {
  static {
    __name(this, "ProtocolNodeMaskFile");
  }
  constructor(options) {
    super(options);
    if ((0, import_NVMFile.gotDeserializationOptions)(options)) {
      this.nodeIdSet = new Set((0, import_safe.parseBitMask)(this.payload));
    } else {
      this.nodeIdSet = new Set(options.nodeIds);
    }
  }
  nodeIdSet;
  get nodeIds() {
    return [...this.nodeIdSet];
  }
  set nodeIds(value) {
    this.nodeIdSet = new Set(value);
  }
  serialize() {
    this.payload = (0, import_safe.encodeBitMask)([...this.nodeIdSet], import_safe.NODE_ID_MAX);
    return super.serialize();
  }
  // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
  toJSON() {
    return {
      ...super.toJSON(),
      "node IDs": [...this.nodeIdSet].join(", ")
    };
  }
}
const ProtocolPreferredRepeatersFileID = 327682;
let ProtocolPreferredRepeatersFile = (() => {
  let _classDecorators = [(0, import_NVMFile.nvmFileID)(ProtocolPreferredRepeatersFileID), (0, import_NVMFile.nvmSection)("protocol")];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = ProtocolNodeMaskFile;
  var ProtocolPreferredRepeatersFile2 = class extends _classSuper {
    static {
      __name(this, "ProtocolPreferredRepeatersFile");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      ProtocolPreferredRepeatersFile2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
  };
  return ProtocolPreferredRepeatersFile2 = _classThis;
})();
const ProtocolNodeListFileID = 327685;
let ProtocolNodeListFile = (() => {
  let _classDecorators = [(0, import_NVMFile.nvmFileID)(ProtocolNodeListFileID), (0, import_NVMFile.nvmSection)("protocol")];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = ProtocolNodeMaskFile;
  var ProtocolNodeListFile2 = class extends _classSuper {
    static {
      __name(this, "ProtocolNodeListFile");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      ProtocolNodeListFile2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
  };
  return ProtocolNodeListFile2 = _classThis;
})();
const ProtocolAppRouteLockNodeMaskFileID = 327686;
let ProtocolAppRouteLockNodeMaskFile = (() => {
  let _classDecorators = [(0, import_NVMFile.nvmFileID)(ProtocolAppRouteLockNodeMaskFileID), (0, import_NVMFile.nvmSection)("protocol")];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = ProtocolNodeMaskFile;
  var ProtocolAppRouteLockNodeMaskFile2 = class extends _classSuper {
    static {
      __name(this, "ProtocolAppRouteLockNodeMaskFile");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      ProtocolAppRouteLockNodeMaskFile2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
  };
  return ProtocolAppRouteLockNodeMaskFile2 = _classThis;
})();
const ProtocolRouteSlaveSUCNodeMaskFileID = 327687;
let ProtocolRouteSlaveSUCNodeMaskFile = (() => {
  let _classDecorators = [(0, import_NVMFile.nvmFileID)(ProtocolRouteSlaveSUCNodeMaskFileID), (0, import_NVMFile.nvmSection)("protocol")];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = ProtocolNodeMaskFile;
  var ProtocolRouteSlaveSUCNodeMaskFile2 = class extends _classSuper {
    static {
      __name(this, "ProtocolRouteSlaveSUCNodeMaskFile");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      ProtocolRouteSlaveSUCNodeMaskFile2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
  };
  return ProtocolRouteSlaveSUCNodeMaskFile2 = _classThis;
})();
const ProtocolSUCPendingUpdateNodeMaskFileID = 327688;
let ProtocolSUCPendingUpdateNodeMaskFile = (() => {
  let _classDecorators = [(0, import_NVMFile.nvmFileID)(ProtocolSUCPendingUpdateNodeMaskFileID), (0, import_NVMFile.nvmSection)("protocol")];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = ProtocolNodeMaskFile;
  var ProtocolSUCPendingUpdateNodeMaskFile2 = class extends _classSuper {
    static {
      __name(this, "ProtocolSUCPendingUpdateNodeMaskFile");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      ProtocolSUCPendingUpdateNodeMaskFile2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
  };
  return ProtocolSUCPendingUpdateNodeMaskFile2 = _classThis;
})();
const ProtocolVirtualNodeMaskFileID = 327689;
let ProtocolVirtualNodeMaskFile = (() => {
  let _classDecorators = [(0, import_NVMFile.nvmFileID)(ProtocolVirtualNodeMaskFileID), (0, import_NVMFile.nvmSection)("protocol")];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = ProtocolNodeMaskFile;
  var ProtocolVirtualNodeMaskFile2 = class extends _classSuper {
    static {
      __name(this, "ProtocolVirtualNodeMaskFile");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      ProtocolVirtualNodeMaskFile2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
  };
  return ProtocolVirtualNodeMaskFile2 = _classThis;
})();
const ProtocolPendingDiscoveryNodeMaskFileID = 327690;
let ProtocolPendingDiscoveryNodeMaskFile = (() => {
  let _classDecorators = [(0, import_NVMFile.nvmFileID)(ProtocolPendingDiscoveryNodeMaskFileID), (0, import_NVMFile.nvmSection)("protocol")];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = ProtocolNodeMaskFile;
  var ProtocolPendingDiscoveryNodeMaskFile2 = class extends _classSuper {
    static {
      __name(this, "ProtocolPendingDiscoveryNodeMaskFile");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      ProtocolPendingDiscoveryNodeMaskFile2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
  };
  return ProtocolPendingDiscoveryNodeMaskFile2 = _classThis;
})();
const ProtocolRouteCacheExistsNodeMaskFileID = 327691;
let ProtocolRouteCacheExistsNodeMaskFile = (() => {
  let _classDecorators = [(0, import_NVMFile.nvmFileID)(ProtocolRouteCacheExistsNodeMaskFileID), (0, import_NVMFile.nvmSection)("protocol")];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = ProtocolNodeMaskFile;
  var ProtocolRouteCacheExistsNodeMaskFile2 = class extends _classSuper {
    static {
      __name(this, "ProtocolRouteCacheExistsNodeMaskFile");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      ProtocolRouteCacheExistsNodeMaskFile2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
  };
  return ProtocolRouteCacheExistsNodeMaskFile2 = _classThis;
})();
const ProtocolLRNodeListFileID = 327692;
let ProtocolLRNodeListFile = (() => {
  let _classDecorators = [(0, import_NVMFile.nvmFileID)(ProtocolLRNodeListFileID), (0, import_NVMFile.nvmSection)("protocol")];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = import_NVMFile.NVMFile;
  var ProtocolLRNodeListFile2 = class extends _classSuper {
    static {
      __name(this, "ProtocolLRNodeListFile");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      ProtocolLRNodeListFile2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
    constructor(options) {
      super(options);
      if ((0, import_NVMFile.gotDeserializationOptions)(options)) {
        this.nodeIdSet = new Set((0, import_safe.parseBitMask)(this.payload, 256));
      } else {
        this.nodeIdSet = new Set(options.nodeIds);
      }
    }
    nodeIdSet;
    get nodeIds() {
      return [...this.nodeIdSet];
    }
    set nodeIds(value) {
      this.nodeIdSet = new Set(value);
    }
    serialize() {
      this.payload = (0, import_safe.encodeBitMask)([...this.nodeIdSet], 1279, 256);
      return super.serialize();
    }
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    toJSON() {
      return {
        ...super.toJSON(),
        "node IDs": [...this.nodeIdSet].join(", ")
      };
    }
  };
  return ProtocolLRNodeListFile2 = _classThis;
})();
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  ProtocolAppRouteLockNodeMaskFile,
  ProtocolAppRouteLockNodeMaskFileID,
  ProtocolLRNodeListFile,
  ProtocolLRNodeListFileID,
  ProtocolNodeListFile,
  ProtocolNodeListFileID,
  ProtocolNodeMaskFile,
  ProtocolPendingDiscoveryNodeMaskFile,
  ProtocolPendingDiscoveryNodeMaskFileID,
  ProtocolPreferredRepeatersFile,
  ProtocolPreferredRepeatersFileID,
  ProtocolRouteCacheExistsNodeMaskFile,
  ProtocolRouteCacheExistsNodeMaskFileID,
  ProtocolRouteSlaveSUCNodeMaskFile,
  ProtocolRouteSlaveSUCNodeMaskFileID,
  ProtocolSUCPendingUpdateNodeMaskFile,
  ProtocolSUCPendingUpdateNodeMaskFileID,
  ProtocolVirtualNodeMaskFile,
  ProtocolVirtualNodeMaskFileID
});
//# sourceMappingURL=ProtocolNodeMaskFiles.js.map
