"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var GetControllerCapabilitiesMessages_exports = {};
__export(GetControllerCapabilitiesMessages_exports, {
  GetControllerCapabilitiesRequest: () => GetControllerCapabilitiesRequest,
  GetControllerCapabilitiesResponse: () => GetControllerCapabilitiesResponse
});
module.exports = __toCommonJS(GetControllerCapabilitiesMessages_exports);
var import_core = require("@zwave-js/core");
var import_serial = require("@zwave-js/serial");
var import_safe = require("@zwave-js/shared/safe");
var __esDecorate = function(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
  function accept(f) {
    if (f !== void 0 && typeof f !== "function") throw new TypeError("Function expected");
    return f;
  }
  __name(accept, "accept");
  var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
  var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
  var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
  var _, done = false;
  for (var i = decorators.length - 1; i >= 0; i--) {
    var context = {};
    for (var p in contextIn) context[p] = p === "access" ? {} : contextIn[p];
    for (var p in contextIn.access) context.access[p] = contextIn.access[p];
    context.addInitializer = function(f) {
      if (done) throw new TypeError("Cannot add initializers after decoration has completed");
      extraInitializers.push(accept(f || null));
    };
    var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
    if (kind === "accessor") {
      if (result === void 0) continue;
      if (result === null || typeof result !== "object") throw new TypeError("Object expected");
      if (_ = accept(result.get)) descriptor.get = _;
      if (_ = accept(result.set)) descriptor.set = _;
      if (_ = accept(result.init)) initializers.unshift(_);
    } else if (_ = accept(result)) {
      if (kind === "field") initializers.unshift(_);
      else descriptor[key] = _;
    }
  }
  if (target) Object.defineProperty(target, contextIn.name, descriptor);
  done = true;
};
var __runInitializers = function(thisArg, initializers, value) {
  var useValue = arguments.length > 2;
  for (var i = 0; i < initializers.length; i++) {
    value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
  }
  return useValue ? value : void 0;
};
let GetControllerCapabilitiesRequest = (() => {
  let _classDecorators = [(0, import_serial.messageTypes)(import_serial.MessageType.Request, import_serial.FunctionType.GetControllerCapabilities), (0, import_serial.expectedResponse)(import_serial.FunctionType.GetControllerCapabilities), (0, import_serial.priority)(import_core.MessagePriority.Controller)];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = import_serial.Message;
  var GetControllerCapabilitiesRequest2 = class extends _classSuper {
    static {
      __name(this, "GetControllerCapabilitiesRequest");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      GetControllerCapabilitiesRequest2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
  };
  return GetControllerCapabilitiesRequest2 = _classThis;
})();
let GetControllerCapabilitiesResponse = (() => {
  let _classDecorators = [(0, import_serial.messageTypes)(import_serial.MessageType.Response, import_serial.FunctionType.GetControllerCapabilities)];
  let _classDescriptor;
  let _classExtraInitializers = [];
  let _classThis;
  let _classSuper = import_serial.Message;
  var GetControllerCapabilitiesResponse2 = class extends _classSuper {
    static {
      __name(this, "GetControllerCapabilitiesResponse");
    }
    static {
      _classThis = this;
    }
    static {
      const _metadata = typeof Symbol === "function" && Symbol.metadata ? Object.create(_classSuper[Symbol.metadata] ?? null) : void 0;
      __esDecorate(null, _classDescriptor = { value: _classThis }, _classDecorators, { kind: "class", name: _classThis.name, metadata: _metadata }, null, _classExtraInitializers);
      GetControllerCapabilitiesResponse2 = _classThis = _classDescriptor.value;
      if (_metadata) Object.defineProperty(_classThis, Symbol.metadata, { enumerable: true, configurable: true, writable: true, value: _metadata });
      __runInitializers(_classThis, _classExtraInitializers);
    }
    constructor(options) {
      super(options);
      this.isSecondary = options.isSecondary;
      this.isUsingHomeIdFromOtherNetwork = options.isUsingHomeIdFromOtherNetwork;
      this.isSISPresent = options.isSISPresent;
      this.wasRealPrimary = options.wasRealPrimary;
      this.isStaticUpdateController = options.isStaticUpdateController;
      this.noNodesIncluded = options.noNodesIncluded;
    }
    static from(raw, _ctx) {
      const capabilityFlags = raw.payload[0];
      const isSecondary = !!(capabilityFlags & import_core.ControllerCapabilityFlags.Secondary);
      const isUsingHomeIdFromOtherNetwork = !!(capabilityFlags & import_core.ControllerCapabilityFlags.OnOtherNetwork);
      const isSISPresent = !!(capabilityFlags & import_core.ControllerCapabilityFlags.SISPresent);
      const wasRealPrimary = !!(capabilityFlags & import_core.ControllerCapabilityFlags.WasRealPrimary);
      const isStaticUpdateController = !!(capabilityFlags & import_core.ControllerCapabilityFlags.SUC);
      const noNodesIncluded = !!(capabilityFlags & import_core.ControllerCapabilityFlags.NoNodesIncluded);
      return new this({
        isSecondary,
        isUsingHomeIdFromOtherNetwork,
        isSISPresent,
        wasRealPrimary,
        isStaticUpdateController,
        noNodesIncluded
      });
    }
    isSecondary;
    isUsingHomeIdFromOtherNetwork;
    isSISPresent;
    wasRealPrimary;
    isStaticUpdateController;
    noNodesIncluded;
    serialize(ctx) {
      this.payload = import_safe.Bytes.from([
        (this.isSecondary ? import_core.ControllerCapabilityFlags.Secondary : 0) | (this.isUsingHomeIdFromOtherNetwork ? import_core.ControllerCapabilityFlags.OnOtherNetwork : 0) | (this.isSISPresent ? import_core.ControllerCapabilityFlags.SISPresent : 0) | (this.wasRealPrimary ? import_core.ControllerCapabilityFlags.WasRealPrimary : 0) | (this.isStaticUpdateController ? import_core.ControllerCapabilityFlags.SUC : 0) | (this.noNodesIncluded ? import_core.ControllerCapabilityFlags.NoNodesIncluded : 0)
      ]);
      return super.serialize(ctx);
    }
  };
  return GetControllerCapabilitiesResponse2 = _classThis;
})();
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  GetControllerCapabilitiesRequest,
  GetControllerCapabilitiesResponse
});
//# sourceMappingURL=GetControllerCapabilitiesMessages.js.map
